Program ESRECSEL;

const
 Reg = $1C;

 Mic = 0;
 CD = 2;
 Line = 6;
 Mix = 7;

var
 Base: Word;
 Source: Byte;

procedure WriteMixer (Val : Byte);
begin
  Port [Base + 4] := Reg;
  Port [Base + 5] := Val;
end;

function ReadMixer: Byte;
begin
  Port [Base + 4] := Reg;
  Readmixer := Port [Base + 5];
end;

function DecodeBase(BaseStr: String): Word;
var
 Value: Word;
 Code: Integer;
begin
 BaseStr := '$' + BaseStr;
 Val(BaseStr, Value, Code);
 if Code = 0 then DecodeBase := Value else DecodeBase := 0;
end;

function DecodeSource(SourceStr: String): Byte;
var
 i : Integer;
begin
 for i := 1 to Length(SourceStr) do
 SourceStr[i] := UpCase(SourceStr[i]);

 if SourceStr = 'MIC' then DecodeSource := Mic
 else if SourceStr = 'CD' then DecodeSource := CD
 else if SourceStr = 'LINE' then DecodeSource := Line
 else if SourceStr = 'MIX' then DecodeSource := Mix
 else DecodeSource := $FF;
end;

Procedure PrintSource (value: Byte);
begin
  case (value and 7) of
   Mic:  Writeln ('Current Recording Source: Mic');
   CD:   Writeln ('Current Recording Source: CD');
   Line: Writeln ('Current Recording Source: Line');
   Mix:  Writeln ('Current Recording Source: Mix');
   else
         Writeln ('Unknown Recording Source: ', value and 7);
  end;
end;

begin
Writeln;
WriteLn ('ESS 1688/1868/1869 Recording Source Selector 1.0 by Falcosoft');
if ParamCount = 0 then
begin
 WriteLn ('Usage: ESRECSEL <ESS Base Port> <Recording Source>');
 WriteLn ('Recording Source can be: Mic, CD, Line, Mix');
 WriteLn ('If only Base Port is given prints the current Recording Source.');
end
else if ParamCount = 1 then
begin
 Base := DecodeBase(ParamStr(1));
 if Base <> 0 then PrintSource(ReadMixer);

end
else
begin
 Base := DecodeBase(ParamStr(1));
 Source := DecodeSource(ParamStr(2));
 if (Base <> 0) and (Source <> $FF) then
 begin
  WriteMixer(Source);
  WriteLn ('New Recording Source is set.');
  PrintSource(ReadMixer);
 end;
end;

end.